<?php
/*
copyright 2009 Fiona Coulter http://www.iswebdesign.co.uk

This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
// no direct access
defined('_JEXEC') or die('Restricted access');

require_once JPATH_SITE.'/components/com_content/helpers/route.php';


class modArticlesCountHelper
{

	public static function getList(&$params)
	{
		//$mainframe = &JFactory::getApplication();

		$db			= JFactory::getDBO();
		$nullDate	= $db->getNullDate();
		$dateFormat = $db->getDateFormat();

		$date = JFactory::getDate();
		$now = $date->format($date);
		$menuitemid = trim($params->get('menuitemid',''));
		$showEmpty = true;
		if($params->get('show_empty','yes') == 'no' && $params->get('show_tree','yes') == 'no')
		{
			$showEmpty = false;
		}
		
		

		
		$where = '(cc.published = 1)';
		
		if ($params->get('show_unpublished','no')=='no')
		{
			if($showEmpty)
			{
				$where		.= ' AND (a.state = 1 OR a.state IS NULL)'
				. ' AND (a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' OR a.publish_up IS NULL)'
				. ' AND (a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' OR a.publish_down IS NULL )';
			}
			else
			{
				$where		.= ' AND (a.state = 1)'
				. ' AND (a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).')'
				. ' AND (a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).')';				
			}
		}
		
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		
		if($params->get('show_no_access_categories','no')=='no')
		{
	        $where .= ' AND (cc.access IN ('.$groups.')) ';
		}
		
		if($params->get('show_no_access_articles','no')=='no')
		{
			if($showEmpty)
			{
			  $where .= ' AND (a.access IN ('.$groups.') OR a.access IS NULL)';
			}
			else
			{
			  $where .= ' AND (a.access IN ('.$groups.')) ';
				
			}
		}
		
		  
	   $lists = new StdClass();
	   $lists->artcount = array();
	   $lists->names = array();
	   
	   $catid = '';
	   
	   
	   
	   $catCondition = '';
	   
	   if( $params->get('use_request','no') == 'yes')
	   {
		    $input = JFactory::getApplication()->input;
	      	if ($input->get('view') == 'category') {
			  $id = intval($input->get('id',0,'int'));
			}
			else if ($input->get('view') == 'article') {
			  $id = intval($input->get('id','','int'));				
			}
			if($id > 0)
			{
			  if($params->get('show_child','no') == 'yes')
			  {
				  $catCondition = ' AND (cc.id='.$id.' OR cc.parent_id='.$id.')';
			  }
			  else
			  {
				  $catCondition = ' AND (cc.id='.$id.')';
			  }
			  
			}
	   
	   }	
		else 
		{
	        $catParam = $params->get('catid','0');
			
			if(is_array($catParam))
			{
				if(! in_array('0',$catParam))
				{
				   $catid	= implode(',', $catParam );
					
				}
			}
			else
			{
				if($catParam != '0') //0 is the root category
				{
				   $catid = trim($catParam);
				}
			}
			  
			if ($catid)
			{
				$ids = explode( ',', $catid );
				JArrayHelper::toInteger( $ids );
				//$catCondition = ' AND (cc.id=' . implode( ' OR cc.id=', $ids ) . ')';
				if($params->get('show_child','no') == 'yes')
				{
				  $catCondition = ' AND (cc.id IN('.implode(',',$ids).') OR cc.parent_id IN('.implode(',',$ids).'))';					
				}
				else
				{
				  $catCondition = ' AND (cc.id IN('.implode(',',$ids).'))';
				}
			}
		}
	   
		$groupby = 'cc.id';
			
		  $query = $db->getQuery(true);
		  $query->select('COUNT(a.id) AS artcount, cc.id AS catid, cc.title AS cattitle, cc.parent_id, cc.level');
		  //$query->from('#__content AS a');
		 // $query->innerJoin('#__categories AS cc ON cc.id = a.catid');
		  $query->from('#__categories AS cc');
		  $query->leftJoin('#__content AS a ON cc.id = a.catid');
		  $query->where($where.$catCondition);
		  $query->group($groupby);
		  $query->order('cc.lft');
		  
			
		  $db->setQuery($query);
		  if (! $db->query() )
		  {
		    //echo $db->getErrorMsg();
			return array();
		  }
          
		  $rows = $db->loadObjectList();
		  $prevParent = 0;
		  $prevLevel = 0;
		  $prevId = 0;
		  $currTag = "";
		  $lists->items = array();
		  $depth = 0;
		  
		  foreach ($rows as $row)
		  {
			   $item = new stdClass();
			   $item->name = $row->cattitle;	
			   $item->subTotal = 0;
			   $item->artcount = $row->artcount;
			   
			   $item->parent_id = $row->parent_id;
			   $item->children = array();
			   $item->id = $row->catid;
			   
			   if($params->get('link_cat','yes')=='yes' || $params->get('show_tree','yes') == 'yes')
			   {
				  if($row->catid > 0)
				  {
					  $link = ContentHelperRoute::getCategoryRoute($row->catid);
					  if(($menuitemid != '') && (strpos($link,'Itemid=') === FALSE))
					  {
						$link .= '&amp;Itemid='.$menuitemid;
						$link = JRoute::_($link);
					  }
					  $item->startLink = '<a href="'.$link.'">';
					  $item->endLink = '</a>';
				  }
				  else
				  {
					  $item->startLink = "";
					  $item->endLink = "";
					  $link = "";
				  }
				  
				   
				   //$item->name = '<a href="'. $link .'">'.$row->cattitle.'</a>';
			   }
			   else
			   {
				   $item->startLink = "";
				   $item->endLink = "";				   
			   }
			   
			   $item->startTag = $currTag . '<li>';
			   //$currTag = '</li>';
			   if($prevParent > 0 && $prevParent != $row->parent_id)
			   {
				 if($row->parent_id == $prevId)
				 {
					 $item->startTag = '<ul><li>';
					 $depth++;
				 }
				 else //its not a child so close up
				 {
					 //new level must be lower
					 $levels = $prevLevel - $row->level;
					 $item->startTag = str_repeat('</li></ul>',$levels).'</li><li>';
					 $depth = $depth - $levels;
				 }
			   }
			   $currTag = '</li>';   
			   
			   
			   $lists->items[$row->catid] = $item;
			   
			   $prevParent = $row->parent_id;
			   $prevLevel = $row->level;
			   $prevId = $row->catid;
		  
		  }
		  if($depth>0)
		  {
			$lists->closeTag = str_repeat('</li></ul>',$depth).'</li>';
		  }
		  $lists->id = uniqid('artcount');
		  $lists->layout = 'default';
		  if( $params->get('show_tree','yes') == 'yes')
		  {
			JHTML::_('behavior.tree',$lists->id, array(),array('text'=>JText::_('ARTCOUNTROOTNAME'),'data'=>array('url'=>'')));
			$lists->layout = 'tree';
		  }
		  
		  if($params->get('show_cumul','no') == 'yes')
		  {
			  //sort out parent child relationships
			  foreach($lists->items as $item)
			  {
				  if($item->id > 0 && isset($lists->items[$item->parent_id]))
				  {
					 $lists->items[$item->parent_id]->children[] = $item->id;
				  }
			  }
			  
			  foreach($lists->items as $item)
			  {
				  if(count($item->children) == 0)
				  {
					  $item->subTotal = $item->artcount;
					  self::addTotal($lists,$item, $item->artcount);
				  }
			  }
			  
			  foreach($lists->items as $item)
			  {
				 $item->artcountText = sprintf(JText::_('ARTCOUNTTEXT'),$item->subTotal);
				 if($params->get('show_zero_blank','yes') == 'yes' && $item->subTotal == 0)
				 {
					$item->artcountText = ""; 
				 }
			  }
		  }
		  else
		  {
			  foreach($lists->items as $item)
			  {
				 $item->artcountText = sprintf(JText::_('ARTCOUNTTEXT'),$item->artcount);
				 if($params->get('show_zero_blank','yes') == 'yes' && $item->artcount == 0)
				 {
					$item->artcountText = ""; 
				 }
			  }
		  }
		  
		  return $lists;		
			
		
    }
	
	private static function addTotal(&$lists, &$item, $amount)
	{
		 if($item->parent_id > 0 && isset($lists->items[$item->parent_id]))
		 {
			 $lists->items[$item->parent_id]->subTotal += $amount;
			 self::addTotal($lists, $lists->items[$item->parent_id], $amount);
		 }
	}


}
